;|							;;
	R E V T A G v. 1.1	(revision TAG)		;;
	By. Andrea Andreetti	17-03-2008		;;
							;;
	fix 1 By A.A. 15-04-2009			;;
	reset variables added and *error* function	;;
							|;
(princ "\n\n    --  R E V T A G  v.1.1 --
By: Andrea Andreetti")


;;;;;;;;;;;;;;;;;;;;;;DEGRE  RADIANS
(defun dtr (a) (* pi (/ a 180.0)))

;;;;;;;;;;;;;;;;;;;;;;RADIANS  DEGRE
(defun rtd (a) (/ (* a 180) pi))


(defun bleader_cer (/ _trota)
;;;Modifi pour DVIEW
  (if (eq (setq _trota (getvar "VIEWTWIST")) 0.0)
    (setq _trota (angle '(0 0 0) (trans (getvar "ucsxdir") 0 '(0.0 0.0 1.0))))
  )
  (setq _trota (- 0.0 _trota))
  (setq lastpoint (getvar "Lastpoint"))
  (setq pt_1 nil
        #elp nil
        barrgflag nil
        barrdflag nil
        barrg nil
        barrd nil
  )
  (while (not #elp)
    (simulpreviewbl_cer)
    (if (/= pickmode 3)
      (redraw)
      (createbleader_cer)
    )
  )
  (redraw)
)




;| Block Leader coordinates			|;
(defun bleader_x (/ _trota gapt)
  (if (eq (strcase sbs) "HEX")
    (setq gapt 1.15499622)
  )
  (if (eq (strcase sbs) "TRI")
    (setq gapt 1.04626773)
  )
  (if (eq (strcase sbs) "CIR")
    (setq gapt 1.0463)
  )

  ;;Modified for DVIEW
  (if (eq (setq _trota (getvar "VIEWTWIST")) 0.0)
    (setq _trota (angle '(0 0 0) (trans (getvar "ucsxdir") 0 '(0.0 0.0 1.0))))
  )
  (setq _trota (- 0.0 _trota))
  (setq lastpoint (getvar "Lastpoint"))
  (setq #pmg (polar lastpoint (+ _trota (dtr 180)) (* sfa gapt)))
  (setq #pmgg (polar #pmg (+ _trota (dtr 180)) (* sfa 0.8)))
  (setq #phg (polar #pmgg (+ _trota (dtr 90)) (* sfa 0.9843)))
  (setq #pbg (polar #pmgg (- _trota (dtr 90)) (* sfa 0.9843)))
  (setq #pmd (polar lastpoint _trota (* sfa gapt)))
  (setq #pmdd (polar #pmd _trota (* sfa 0.8)))
  (setq #phd (polar #pmdd (+ _trota (dtr 90)) (* sfa 0.9843)))
  (setq #pbd (polar #pmdd (- _trota (dtr 90)) (* sfa 0.9843)))
  (setq pt_1 nil
        #elp nil
        barrgflag nil
        barrdflag nil
        barrg nil
        barrd nil
  )
  (while (not #elp)
    (simulpreviewbl)
    (if (/= pickmode 3)
      (progn (redraw))
      (createbleader)
    )
  )
)





;;LEADER SIMULATION GRDRAW
(defun simulpreviewbl ()
  (while (= (car (setq grr (grread t 4))) 5)
    (setq #elp (car (cdr grr)))
    (redraw)
    (if (< (distance #elp #pmg) (distance #elp #pmd))
      ;;cot Gauche
      (progn (setq inter "G")
             (setq #slp #pmgg)
             ;;MTEXT avec LINE
             (grdraw #pmg #pmgg 141 1)
             (if (inters #pmg #phg #pmgg #elp)
               (progn (grdraw #pmgg #phg 141 1)
                      (setq #slp #phg)
                      (setq inter "HG")
               )
             )
             (if (inters #pmg #pbg #pmgg #elp)
               (progn (grdraw #pmgg #pbg 141 1)
                      (setq #slp #pbg)
                      (setq inter "BG")
               )
             )
             (grdraw #slp #elp 141 1)
      )
      ;;cot Droit
      (progn (setq inter "D")
             (setq #slp #pmdd)
             ;;MTEXT avec LINE
             (grdraw #pmd #pmdd 243 1)
             (if (inters #pmd #phd #pmdd #elp)
               (progn (grdraw #pmdd #phd 243 1)
                      (setq #slp #phd)
                      (setq inter "HD")
               )
             )
             (if (inters #pmd #pbd #pmdd #elp)
               (progn (grdraw #pmdd #pbd 243 1)
                      (setq #slp #pbd)
                      (setq inter "BD")
               )
             )
             (grdraw #slp #elp 243 1)
      )
    )
  )
  (setq pickmode (car grr))
)





(defun simulpreviewbl_cer ()
  (while (= (car (setq grr (grread t 4))) 5)
    (setq #elp (car (cdr grr)))
    (redraw)
    ;;MTEXT avec LINE
    (grdraw lastpoint #elp 141 1)
  )
  (setq #slp (polar lastpoint (angle lastpoint #elp) (* sfa 1.1550)))
  (setq pickmode (car grr))
)





(defun createbleader_cer ()
  (setq osmode (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (vl-cmdf "._Leader" #elp #slp "_A" "" "_N")
  (vl-cmdf "._chprop"
           (entlast)
           ""
           "_LA"
           tlay
           "_CO"
           dimclrd
           ""
  )
  (setvar "OSMODE" osmode)
  (setq #elp nil) ;APPname   	  Entit	XDATA
  (revtag_put_xdata tagblock5 (entlast) tagblock2)
)








(defun createbleader ()
  (setq osmode (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (if (eq inter "G")
    (vl-cmdf "._Leader" #elp #pmgg #pmg "_A" "" "_N")
  )
  (if (eq inter "HG")
    (vl-cmdf "._Leader" #elp #slp #pmgg #pmg "_A" "" "_N")
  )
  (if (eq inter "BG")
    (vl-cmdf "._Leader" #elp #slp #pmgg #pmg "_A" "" "_N")
  )
  (if (eq inter "D")
    (vl-cmdf "._Leader" #elp #pmdd #pmd "_A" "" "_N")
  )
  (if (eq inter "HD")
    (vl-cmdf "._Leader" #elp #slp #pmdd #pmd "_A" "" "_N")
  )
  (if (eq inter "BD")
    (vl-cmdf "._Leader" #elp #slp #pmdd #pmd "_A" "" "_N")
  )
  (vl-cmdf "._chprop"
           (entlast)
           ""
           "_LA"
           tlay
           "_CO"
           dimclrd
           ""
  )
  (setvar "OSMODE" osmode)
  (setq #elp nil) ;APPname   	  Entit	XDATA
  (revtag_put_xdata tagblock5 (entlast) tagblock2)
)




(defun revtag_put_xdata (appname enty xdta / ent type1 valeur)
  ;;SET XDATA
  (vl-load-com)
  (setq ent (vlax-ename->vla-object enty))
  (setq type1  (vlax-make-safearray vlax-vbinteger (cons 0 1))
        valeur (vlax-make-safearray vlax-vbvariant (cons 0 1))
  )
  (vlax-safearray-put-element type1 0 1001)
  (vlax-safearray-put-element valeur 0 appname) ;"RevTag") 
  (vlax-safearray-put-element type1 1 1000)
  (vlax-safearray-put-element
    valeur
    1
    (vl-princ-to-string xdta)
  )
  (setq type1  (vlax-make-variant type1)
        valeur (vlax-make-variant valeur)
  )
  (vla-setxdata ent type1 valeur)
)





(defun revtag_get_xdata (item)
  ;;GET XDATA
  (setq ent (vlax-ename->vla-object item))
  (vla-getxdata ent "RevTag" 'type1 'valeur)
  (if valeur
    (setq pte (vlax-variant-value (nth 1 (vlax-safearray->list valeur))))
  )
)





(defun checkrtblock ()
  (setq trb (ssget "X"
                   '((0 . "INSERT")
                     (2 . "TAG_CIR,TAG_TRI,TAG_HEX")
                     (-3 ("RevTag"))
                    )
            )
  )
  (if trb
    (progn (setq sscount (sslength trb))
           
           (setq val1 (- sscount 1))
           
           (repeat sscount
             
             (setq ent (entget (ssname trb val1)))
             ;;dtail de l'entit
             
             (setq a10 (cdr (assoc 10 ent)))
             (setq a05 (cdr (assoc 5 ent)))
             (setq a41 (cdr (assoc 41 ent)))
             (setq a10l (vl-princ-to-string
                          (list (rtos (nth 0 a10) 2 8) (rtos (nth 1 a10) 2 8))
                        )
             )
             (setq a02 (cdr (assoc 2 ent)))
             
             (setq xd1 (revtag_get_xdata (ssname trb val1)))
             (if (and xd1 (/= xd1 a10l))
               (progn (setq ndist (distance (read xd1) (read a10l)))
                      (setq nangl (angle (read xd1) (read a10l)))
                      (revtag_update_leader a10)
               )
             )
             (setq val1 (- val1 1))
           )
    )
  )
)





(defun revtag_update_leader (ncoor)
  (setq ncoor1 (list (rtos (nth 0 ncoor) 2 8) (rtos (nth 1 ncoor) 2 8)))

 ;APPname   	  Entit		XDATA
  (revtag_put_xdata "RevTag" (ssname trb val1) ncoor1)
  (setq rtl (ssget "X"
                   (list '(0 . "LEADER") (cons -3 (list (list a05))))
            )
  )
  (if rtl
    (if (eq a02 "TAG_CIR")
      ;;	pour TAG_CIR
      (progn (setq sscountl (sslength rtl))
             
             (setq vall1 (- sscountl 1))
             
             (repeat sscountl
               (setq entl (entget (ssname rtl vall1)))
               (setq d1 (* a41 1.1550))
               (setq ep (cons 10 (polar a10 (angle a10 (cdr (assoc 10 entl))) d1)))
               (setq itc (reverse entl))
               (setq rta (assoc 10 itc))
               (setq rtb ep)
               (setq itm (reverse (subst rtb rta itc)))
               (entmod itm)
               (setq vall1 (- vall1 1))
             )
      )
      ;;	pour TAG_TRI et TAG_HEX
      (progn (if (eq a02 "TAG_HEX")
               (setq d1 (* a41 1.1550))
               (setq d1 (* a41 1.0463))
             )
             (setq sscountl (sslength rtl))
             
             (setq vall1 (- sscountl 1))
             (repeat sscountl
               (setq entl (entget (ssname rtl vall1)))
               (setq nentlist ())
               (setq v 1)
               (foreach n entl
                 (if (eq (car n) 10)
                   (progn (set (read (strcat "np" (itoa v)))
                               (cons 10 (polar (cdr n) nangl ndist))
                          )
                          (setq v (1+ v))
                   )
                 )
               )
               (setq np1 (assoc 10 entl))
               (setq v 1)
               (setq n10list ())
               (setq nentlist ())
               (foreach n entl
                 (if (eq (car n) 10)
                   (progn (setq nentlist (append nentlist
                                                 (list (eval (read (strcat "np" (itoa v)))))
                                         )
                          )
                          (setq v (1+ v))
                   )
                   (setq nentlist (append nentlist (list n)))
                 )
               )
               (entmod nentlist)
               (setq vall1 (- vall1 1))
             ) ;_repeat
      ) ;_progn
    )
  )
)


(defun resetREVTAGvar ()
(if v_insunits (setvar "INSUNITS" v_insunits))
(if v_attdia   (setvar "ATTDIA" v_attdia))
(if v_attreq   (setvar "ATTREQ" v_attreq))
(if osmode     (setvar "OSMODE" osmode))
(if v_insunitsdeftarget (setvar "INSUNITSDEFTARGET" v_insunitsdeftarget))
(if v_insunitsdefsource (setvar "INSUNITSDEFSOURCE" v_insunitsdefsource))    
(REVTAGfinishMode)
)


(defun REVTAGfinishMode (/ var)
  (redraw)  
  (foreach var '(v_insunits v_attdia v_attreq liner    linel    ent_sel1 sbs      sbspath  bbloc    _trota   b1
                            btag     nds      b2       tagblock tagblock2         tagblock5         tagblock10
                            tagcoord tlay     dimclrd  ncoor    ncoor1   trb      val1     rtl      a02      a05
                            sscountl entl     nentlist v        np1      n10list  vall1    trb      a10      a05
                            a41      a10l     a02      xd1      ndist    nangl    valeur   pte      inter    osmode
                            #elp     #pmgg    #pmg     #slp     #pmdd    #pmd     #elp     grr      pickmode #phd
                            #phg     pt_1     #elp     barrgflag         barrdflag         barrg    barrd    #slp
                           )
    (set var nil)
  )
)



;;			S T A R T
(defun c:revtag ()


(defun *error* (msg)
(resetREVTAGvar)
(princ (strcat "\n" msg))
)
  
(revtag_run_reac)

(setq v_insunits (getvar "INSUNITS"))
(setq v_insunitsdeftarget (getvar "INSUNITSDEFTARGET"))
(setq v_insunitsdefsource (getvar "INSUNITSDEFSOURCE"))  
(setq v_attdia   (getvar "ATTDIA"))
(setq v_attreq   (getvar "ATTREQ"))  
  
(setvar "INSUNITS" 0)
(setvar "ATTDIA" 0)
(setvar "ATTREQ" 1)
  
  (setq liner nil
        linel nil
        ent_sel1 nil
  )
  (if (or (/= sbs "CIR") (/= sbs "TRI") (/= sbs "HEX"))
    (setq sbs "CIR")
  )
  (initget "TRI HEX CIR")
  (setq sbs (getkword (strcat "\nTRIangle HEXagon CIRcle <" sbs ">: ")))
  (if (not sbs)
    (setq sbs "CIR")
  )
  ;;CHANGE THIS PATH AS PER YOUR BLOCK LOCATION
  (setq sbspath "x:\\DEPARTEMENT\\GENERAL\\BLOCK\\TAG_")

  (if (findfile (setq bbloc (strcat sbspath sbs ".dwg")))
    (progn ;;Modification suite au DVIEW
           (if (eq (setq _trota (getvar "VIEWTWIST")) 0.0)
             (setq _trota (angle '(0 0 0) (trans (getvar "ucsxdir") 0 '(0.0 0.0 1.0))))
           )
           (setq _trota (- 0.0 _trota))
           (setq b1 (getpoint "\nInsertion Point..."))
           (setq sfa (getreal "\nScale: "))
           (if (not sfa)
             (setq sfa 1.0)
           )
           (setq btag (strcase (getstring "\nRevision: ")))
           (setvar "LASTPOINT" b1)
           (setq nds sfa)
           (setq sfa sfa)
           (setvar "dimscale" sfa)
           (if (and b1 btag)
             (progn (setq b2 (polar b1 _trota 10.0))                    
                    (vl-cmdf "_-insert" bbloc b1 sfa sfa b2 btag)
                    (setq tagblock (entlast))
                    (setq tagblock2 (cdr (assoc 2 (entget tagblock))))
                    (setq tagblock5 (cdr (assoc 5 (entget tagblock))))
                    (setq tagblock10 (cdr (assoc 10 (entget tagblock))))
                    (setq tagcoord (list (rtos (nth 0 tagblock10) 2 8)
                                         (rtos (nth 1 tagblock10) 2 8)
                                   )
                    ) ;APPname   	  Entit	XDATA
                    (revtag_put_xdata "RevTag" tagblock tagcoord)
                    (setq tlay (cdr (assoc 8 (entget (entlast)))))
                    (setq dimclrd (getvar "dimclrd"))
                    (if (eq dimclrd 0)
                      (setq dimclrd "BYLAYER")
                    )
                    (if (eq dimclrd 256)
                      (setq dimclrd "BYBLOCK")
                    )
                    (if (eq sbs "CIR")
                      (bleader_cer)
                      (bleader_x)
                    )
             )
           )
    )
    (alert (strcat "Block " bbloc " not found."))
  )
(resetREVTAGvar)  
)



;|	REACTOR SECTION		|;
				;;
;;Reactor on ended MOVE
(defun *rtmoveended* (call-reactor sci /)
  (if (member (car sci)
              (list "MOVE" "STRETCH" "GRIP_MOVE" "GRIP_STRETCH")
      )
    (checkrtblock)
  )
)

(defun revtag_run_reac ()
  (if rtmoveended
    (progn (vlr-remove rtmoveended) (setq rtmoveended nil))
  )
  (setq rtmoveended (vlr-command-reactor nil
                                         '((:vlr-commandended . *rtmoveended*))
                    )
  )
)
(revtag_run_reac)
				;;
;|	REACTOR SECTION		|;




















;|Visual LISP Format Options
(120 2 1 2 nil "Ende von " 60 20 1 1 0 nil nil nil T)
;*** NE PAS AJOUTER de texte au-dessous du commentaire! ***|;
